/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/diag.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:33:52 $
 * $Log: diag.c,v $
 *	Revision 1.2  1993/10/24  18:33:52  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:39:31  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "diag.h"
#include "diskbios.h"

#define TRACK_MAX 160 /* 154 */

typedef enum DENSITY {
  UNFORMATED, SINGLE_DENS, DOUBLE_DENS, MIXED_DENS
} dens;

static dens density;
static int offset, dataSize;

static void prit(void);
static CMD_PARAM_BUF cmd;

int Visual()
{
  int key;

  B_LOCATE(0,31);
  cmd.buf_ptr = Malloc(cmd.buf_len);
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  NulFuncKey();
  FNCKEYST(1, MesFKeyDrive);
  FNCKEYST(4, MesFKeyBar);
  FNCKEYST(5, MesFKeyBar);
  FNCKEYST(6, " ׯ");
  FNCKEYST(7, " Oׯ");
  FNCKEYST(17, " ׯNo");
  Window(24, 9, 48, 16);
  B_LOCATE(24, 7);
  B_PRINT("\33[32m012345678901234567890123456789012345678901234567");
  B_LOCATE(32, 27);
  B_PRINT(MesRetESC);
  B_LOCATE(38, 4);
  B_PRINT("\33[36m[[[ \33[35m \33[36m]]]");
  key = 0;
  while (key == 0)
    {
      B_CUROFF();
      cmd.cmd = CMD_SEEK;
      diskbios(&cmd);
      cmd.cmd = CMD_READ_DIAG;
      if (density == DOUBLE_DENS)
	{
	  FNCKEYST(4, " single");
	  FNCKEYST(5, MesFKeyBar);
	  cmd.cmd |= OPT_MFM_MODE;
	}
      else
	{
	  FNCKEYST(4, MesFKeyBar);
	  FNCKEYST(5, " double");
	}
      if (diskbios(&cmd) & 0x40000000)
	setmem((char *)(cmd.buf_ptr), cmd.buf_len, 0);
      B_LOCATE(8, 5);
      B_PRINT(MesDriveNo);
      B_COLOR(7);
      PrintDec(cmd.drive, 3);
      B_PRINT(Mes4Spaces);
      B_PRINT((cmd.disktype == 1) ? Mes2DD : Mes2HD);
      B_PRINT(Mes4Spaces);
      B_PRINT(MesTrackNo);
      B_COLOR(7);
      PrintDec(cmd.track, 3);
      B_PRINT(Mes4Spaces);
      B_PRINT("\33[35m");
      B_PRINT((density == SINGLE_DENS) ? MesSingle : MesDouble);
      B_PRINT(Mes4Spaces);
      B_PRINT(MesResult);
      B_PUTC('$');
      PutHex(cmd.results[0] >> 4);
      PutHex(cmd.results[0]);
      B_PUTC(' ');
      PutHex(cmd.results[1] >> 4);
      PutHex(cmd.results[1]);
      B_PUTC(' ');
      PutHex(cmd.results[2] >> 4);
      PutHex(cmd.results[2]);
      B_LOCATE(82, 6);
      if (cmd.results[0] & 0x40)
	B_PRINT("\33[36mERRORS");
      else
	B_PRINT(Mes6Spaces);
      B_COLOR(3);
      B_CUROFF();
      DumpVisual(cmd.buf_ptr);
      key = -1;
      while (key < 0)
	{
	  B_CUROFF();
	  key = GetKey();
	  switch (key)
	    {
	    case 0x01:
	      CheckShift();
	      continue;
	    case 0x63:/* F1 */
	      if (ShiftKey)
		break;
	      key = -2;
	      while (key < -1 || key > 3)
		{
		  B_LOCATE(35, 29);
		  B_PRINT(MesDriveNoQ);
		  B_LOCATE(58, 29);
		  key = GetNum(10, 1, cmd.drive);
		}
	      B_LOCATE(0, 29);
	      B_ERA_AL();
	      if (key != ERROR)
		{
		  cmd.drive = key;
		  key = 0;
		}
	      continue;
	    case 0x66:/* F4 */
	      if (ShiftKey)
		break;
	      if (density == DOUBLE_DENS)
		{
		  density = SINGLE_DENS;
		  key = 0;
		}
	      else
		key = -1;
	      continue;
	    case 0x67:/* F5 */
	      if (ShiftKey)
		break;
	      if (density == SINGLE_DENS)
		{
		  density = DOUBLE_DENS;
		  key = 0;
		}
	      else
		key = -1;
	      continue;
	    case 0x68:/* F6 */
	      if (ShiftKey)
		break;
	      if (++cmd.track == TRACK_MAX)
		cmd.track = 0;
	      key = 0;
	      continue;
	    case 0x69:/* F7 */
	      if (ShiftKey)
		{
		  key = -2;
		  while (key < -1 || key > TRACK_MAX-1)
		    {
		      B_LOCATE(35, 29);
		      B_PRINT(MesTrackNoQ);
		      B_LOCATE(60, 29);
		      key = GetNum(10, 3, cmd.track);
		    }
		  B_LOCATE(0, 29);
		  B_ERA_AL();
		  if (key != ERROR)
		    {
		      cmd.track = key;
		      key = 0;
		    }
		}
	      else
		{
		  if (cmd.track-- == 0)
		    cmd.track = TRACK_MAX-1;
		  key = 0;
		}
	      continue;
	    default:
	      break;
	    }
	  key = -1;
	}
    }
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  free(cmd.buf_ptr);
  Clear23();
  NulFuncKey();
  return 0;
}

int VisualSel()
{
drive_in:
  B_LOCATE(0, 24);
  B_CLR_ED();
  cmd.drive = 255;
  while (cmd.drive > 3)
    {
      B_LOCATE(36, 23);
      B_PRINT(MesDriveNoQ);
      B_LOCATE(59, 23);
      cmd.drive = GetNum(10, 1, 0);
      if (cmd.drive == 255)
	return 0;
    }
disktype_in:
  B_LOCATE(0, 25);
  B_CLR_ED();
  cmd.disktype = 2;
  while (cmd.disktype > 1)
    {
      B_LOCATE(31, 24);
      B_PRINT(MesDiskTypeQ);
      B_LOCATE(64, 24);
      switch(GetKey())
	{
	case 0x4f:/* 0 */
	case 0x0b:/* 0 */
	  cmd.disktype = 0;
	  B_PRINT("2HD");
	  break;
	case 0x4b:/* 1 */
	case 0x02:/* 1 */
	  cmd.disktype = 1;
	  B_PRINT("2DD/2D");
	  break;
	case 0x01:/* ESC */
	  goto drive_in;
	}
    }
track_in:
  B_LOCATE(0, 26);
  B_CLR_ED();
  cmd.track = 255;
  while (cmd.track > TRACK_MAX-1)
    {
      B_LOCATE(35, 25);
      B_PRINT(MesTrackNoQ);
      B_LOCATE(60, 25);
      cmd.track = GetNum(10, 3, 0);
      if (cmd.track == 255)
	goto disktype_in;
    }
/* density_in */
  density = UNFORMATED;
  while (density == UNFORMATED)
    {
      B_LOCATE(30, 26);
      B_PRINT(MesDensity);
      B_LOCATE(64, 26);
      switch(GetKey())
	{
	case 0x4f:/* 0 */
	case 0x0b:/* 0 */
	  density = DOUBLE_DENS;
	  B_PRINT("double");
	  break;
	case 0x4b:/* 1 */
	case 0x02:/* 1 */
	  density = SINGLE_DENS;
	  B_PRINT("single");
	  break;
	case 0x01:/* ESC */
	  goto track_in;
	default:
	  density = UNFORMATED;
	  break;
	}
    }
  cmd.params[3] = 7;
  cmd.params[4] = cmd.params[5] = 1;
  cmd.params[6] = 0xFF;
  cmd.params[0] = cmd.params[1] = cmd.params[2] = 0;
  cmd.cmd = CMD_READ_DIAG;
  if (density == DOUBLE_DENS)
    cmd.cmd |= OPT_MFM_MODE;
  cmd.buf_len = 0x4000;
  B_LOCATE(0, 23);
  B_CLR_ED();
  B_CUROFF();
  return 1;
}

int Cleaning()
{
  B_CUROFF();
  cmd.buf_ptr = Malloc(cmd.buf_len);
  for (cmd.track = 0; cmd.track < TRACK_MAX; ++cmd.track)
    {
      cmd.cmd = CMD_SEEK;
      diskbios(&cmd);
      cmd.cmd = CMD_READ_DIAG;
      diskbios(&cmd);
      cmd.track += 3;
      cmd.cmd = CMD_SEEK;
      diskbios(&cmd);
      cmd.cmd = CMD_READ_DIAG;
      diskbios(&cmd);
    }
  free(cmd.buf_ptr);
  return 0;
}

int CleaningSel()
{
  B_LOCATE(0, 24);
  B_CLR_ED();
  cmd.drive = 255;
  while (cmd.drive > 3)
    {
      B_LOCATE(35, 23);
      B_PRINT(MesDriveNoQ);
      B_LOCATE(58, 23);
      cmd.drive = GetNum(10, 1, 0);
      if (cmd.drive == 255)
	return 0;
    }
  cmd.track = 0;
  density = SINGLE_DENS;
  cmd.params[3] = 7;
  cmd.params[4] = cmd.params[5] = 1;
  cmd.params[6] = 0xFF;
  cmd.params[0] = cmd.params[1] = cmd.params[2] = 0;
  cmd.cmd = CMD_READ_DIAG;
  cmd.buf_len = 0x2000;
  B_LOCATE(0, 23);
  B_CLR_ED();
  B_CUROFF();
  return 1;
}

int Diag(int flag)
{
  uchar cmdSave;

  B_LOCATE(0,31);
  cmdSave = cmd.cmd;
  cmd.cmd = CMD_SEEK;
  diskbios(&cmd);
  if (flag)
    cmd.buf_ptr = Malloc(cmd.buf_len);
  cmd.cmd = cmdSave;
  diskbios(&cmd);
  offset = 0;
  return dataSize;
}

int DiagSel()
{
  int work;

drive_in:
  B_LOCATE(0, 24);
  B_CLR_ED();
  cmd.drive = 255;
  while (cmd.drive > 3)
    {
      B_LOCATE(36, 23);
      B_PRINT(MesDriveNoQ);
      B_LOCATE(59, 23);
      cmd.drive = GetNum(10, 1, 0);
      if (cmd.drive == 255)
	return 0;
    }
disktype_in:
  B_LOCATE(0, 25);
  B_CLR_ED();
  cmd.disktype = 2;
  while (cmd.disktype > 1)
    {
      B_LOCATE(31, 24);
      B_PRINT(MesDiskTypeQ);
      B_LOCATE(64, 24);
      switch(GetKey())
	{
	case 0x4f:/* 0 */
	case 0x0b:/* 0 */
	  cmd.disktype = 0;
	  B_PRINT("2HD");
	  break;
	case 0x4b:/* 1 */
	case 0x02:/* 1 */
	  cmd.disktype = 1;
	  B_PRINT("2DD/2D");
	  break;
	case 0x01:/* ESC */
	  goto drive_in;
	}
    }
track_in:
  B_LOCATE(0, 26);
  B_CLR_ED();
  cmd.track = 255;
  while (cmd.track > TRACK_MAX-1)
    {
      B_LOCATE(35, 25);
      B_PRINT(MesTrackNoQ);
      B_LOCATE(60, 25);
      cmd.track = GetNum(10, 3, 0);
      if (cmd.track == 255)
	goto disktype_in;
    }
density_in:
  B_LOCATE(0, 27);
  B_CLR_ED();
  density = UNFORMATED;
  while (density == UNFORMATED)
    {
      B_LOCATE(30, 26);
      B_PRINT(MesDensity);
      B_LOCATE(64, 26);
      switch (GetKey())
	{
	case 0x4f:/* 0 */
	case 0x0b:/* 0 */
	  density = DOUBLE_DENS;
	  B_PRINT("double");
	  break;
	case 0x4b:/* 1 */
	case 0x02:/* 1 */
	  density = SINGLE_DENS;
	  B_PRINT("single");
	  break;
	case 0x01:/* ESC */
	  goto track_in;
	default:
	  density = UNFORMATED;
	  break;
	}
    }
length_in:
  B_LOCATE(0, 28);
  B_CLR_ED();
  cmd.params[3] = 0;
  while (cmd.params[3] < 1 || cmd.params[3] > 8)
    {
      B_LOCATE(35, 27);
      B_PRINT("\33[37msector length (1 - 8) ?  ");
      B_LOCATE(59, 27);
      cmd.params[3] = GetNum(10, 1, 7);
      if (cmd.params[3] == 255)
	goto density_in;
    }
  work = 0x100 >> cmd.params[3];
/* sectors_in */
  cmd.params[4] = 0;
  while (cmd.params[4] == 0 || cmd.params[4] > work)
    {
      B_LOCATE((work > 99) ? 33 : 34, 28);
      B_PRINT("\33[37mnumber of sectors (1 - ");
      PrintDec(work, (work > 99) ? 3 : ((work > 9) ? 2 : 1));
      B_PRINT(") ?   ");
      B_LOCATE((work > 9) ? 63 : 62, 28);
      cmd.params[4] = GetNum(10, 2, work);
      if (cmd.params[4] == 255)
	goto length_in;
    }
  cmd.params[5] = 1;
  cmd.params[6] = 0xFF;
  cmd.params[0] = cmd.params[1] = cmd.params[2] = 0;
  cmd.cmd = CMD_READ_DIAG;
  if (density == DOUBLE_DENS)
    cmd.cmd |= OPT_MFM_MODE;
  dataSize = 0x80 << cmd.params[3];
  cmd.buf_len = cmd.params[4] * dataSize;
  B_LOCATE(0, 23);
  B_CLR_ED();
  B_CUROFF();
  return 1;
}

void DiagRead(uchar *ptr)
{
  if (cmd.results[0] & 0x40)
    setmem((char *)ptr, dataSize, 0);
  else
    movmem((char *)(cmd.buf_ptr) + offset * dataSize, (char *)ptr, dataSize);
  prit();
}

void DiagDriveIn()
{
  int c;

  c = 0x1000;
  while (c > 3)
    {
      B_LOCATE(35, 29);
      B_PRINT(MesDriveNoQ);
      B_LOCATE(58, 29);
      c = GetNum(10, 1, -1);
    }
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  if (c != ERROR)
    cmd.drive = c;
}

void DiagTrackIn()
{
  int c;

  c = 0x1000;
  while (c >= TRACK_MAX)
    {
      B_LOCATE(35, 29);
      B_PRINT(MesTrackNoQ);
      B_LOCATE(60, 29);
      c = GetNum(10, 3, -1);
    }
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  if (c != ERROR)
    cmd.track = c;
}

void DiagTrackHead()
{
  cmd.track = 0;
}

void DiagTrackInc()
{
  if (++cmd.track == TRACK_MAX)
    cmd.track = 0;
}

void DiagTrackDec()
{
  if (--cmd.track == 255)
    cmd.track = TRACK_MAX-1;
}

void DiagIn()
{
  int c;

  c = 0x1000;
  while (c == 0 || c > cmd.params[4])
    {
      B_LOCATE(35, 29);
      B_PRINT("\33[37msector number (1 - ");
      PrintDec(cmd.params[4], 2);
      B_PRINT(") ?   ");
      B_LOCATE(60, 29);
      c = GetNum(10, 2, -1);
    }
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  if (c != ERROR)
    offset = c - 1;
}

void DiagHead()
{
  offset = 0;
}

int DiagInc()
{
  if (++offset == cmd.params[4])
    {
      offset = 0;
      return ERROR;
    }
  return 0;
}

int DiagDec()
{
  if (--offset == -1)
    {
      offset = cmd.params[4] - 1;
      return ERROR;
    }
  return 0;
}

static void prit()
{
  int i;

  B_LOCATE(8, 4);
  B_PRINT(MesDriveNo);
  B_COLOR(7);
  PrintDec(cmd.drive, 3);
  B_COLOR(1);
  B_PRINT(Mes4Spaces);
  B_PRINT((cmd.disktype == 1) ? Mes2DD : Mes2HD);
  B_PRINT(Mes4Spaces);
  B_PRINT(MesTrackNo);
  B_COLOR(7);
  PrintDec(cmd.track, 3);
  B_PRINT(Mes4Spaces);
  B_PRINT("\33[35m");
  B_PRINT((density == SINGLE_DENS) ? MesSingle : MesDouble);
  B_PRINT(Mes4Spaces);
  B_PRINT(MesResult);
  B_PUTC('$');
  PutHex(cmd.results[0] >> 4);
  PutHex(cmd.results[0]);
  B_PUTC(' ');
  PutHex(cmd.results[1] >> 4);
  PutHex(cmd.results[1]);
  B_PUTC(' ');
  PutHex(cmd.results[2] >> 4);
  PutHex(cmd.results[2]);
  if (cmd.results[0] & 0x40)
    {
      B_LOCATE(11, 5);
      B_PRINT(Mes17Spaces);
      B_LOCATE(82, 5);
      B_PRINT("\33[36mERRORS");
    }
  else
    {
      B_LOCATE(82, 5);
      B_PRINT(Mes6Spaces);
      B_LOCATE(11, 5);
      B_PRINT("\33[31moffset      length \33[37m$    ");
      B_LOCATE(18, 5);
      PrintDec(offset + 1, 3);
      B_LOCATE(31, 5);
      for (i = 12; i >= 0; i -= 4)
	PutHex(dataSize >> i);
    }
  B_COLOR(3);
  B_CUROFF();
}
