/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/editmem.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:36:08 $
 * $Log: editmem.c,v $
 *	Revision 1.2  1993/10/24  18:36:08  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:41:34  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "search.h"
#include "edit.h"

void MemEdit()
{
  edit(0, 0x20000000, 0, funcMem);
}

static int topOfFree;
static int division;
static srchbuf *searchBuffer;
#define MIN_BUF_SIZE	   (0x00010000)
#define MIN_BUF_LOWER_MASK (MIN_BUF_SIZE - 1)
#define MIN_BUF_UPPER_MASK (~MIN_BUF_LOWER_MASK)

void memSearchInit(uchar *address, srchbuf *searchBuf, int is_forward)
{
  searchBuffer = searchBuf;
  topOfFree = B_LPEEK((unsigned long *)0x00001c00);
  topOfFree = (topOfFree + MIN_BUF_LOWER_MASK) & MIN_BUF_UPPER_MASK;
  division = (int)address & MIN_BUF_UPPER_MASK;
  if (topOfFree <= division & division < 0x00c00000)
    division = is_forward ? 0x00c00000 : topOfFree - MIN_BUF_SIZE;
  searchBuffer->buf_top = (uchar *)division;
  searchBuffer->buf_end = (uchar *)division + MIN_BUF_LOWER_MASK;
}

int funcMem(int keyNo)
{
  switch (keyNo)
    {
    case FUNC_PRE:
      B_LOCATE(33, 3);
      B_PRINT("\33[36m[[[ \33[35m@ \33[36m]]]");
      B_CUROFF();
      FNCKEYST(8, MesFKeyAdrsC);
      return 0;
    case 8:
      B_LOCATE(40, 29);
      B_PRINT("\33[37mAhX H $");
      keyNo = GetNum(16, 8, adrEdit);
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (keyNo == ERROR)
	break;
      if (topEdit > keyNo)
	keyNo = topEdit;
      if (endEdit < keyNo)
	keyNo = endEdit;
      adrEdit = keyNo;
      Dump(adrEdit, topEdit - offset);
      break;
    case 9:
    case 10:
      return FUNC_ERROR;
    case 29:
      if (division == 0x20000000 - MIN_BUF_SIZE)
	return FUNC_ERROR;
      keyNo = (topOfFree - MIN_BUF_SIZE <= division && division < 0x00c00000) ?
	      0x00c00000 - division : MIN_BUF_SIZE;
      goto miniBuf;
    case 30:
      if (division == 0x00000000)
	return FUNC_ERROR;
      keyNo = (topOfFree < division && division <= 0x00c00000) ?
	      topOfFree - MIN_BUF_SIZE - division : - MIN_BUF_SIZE;
    miniBuf:
      division += keyNo;
      searchBuffer->buf_top += keyNo;
      searchBuffer->buf_cur += keyNo;
      searchBuffer->buf_end += keyNo;
      return FUNC_NORMAL;
    default:
      break;
    }
  return FUNC_NORMAL;
}
