/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/editsector.c,v $
 * $Author: kawamoto $
 * $Revision: 1.3 $
 * $Date: 1995/05/08 01:04:08 $
 * $Log: editsector.c,v $
 *	Revision 1.3  1995/05/08  01:04:08  kawamoto
 *	Version 2.26b
 *
 *	Revision 1.2  1993/10/24  18:36:24  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:41:49  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "error.h"
#include "search.h"
#include "edit.h"
#include "debug.h"

static int funcSect(int);

int SectorEdit(int sctr)
{
  /* 94/9/14 */
  maxSector = DPBbuf.datasec + (DPBbuf.maxfat - 3) * (DPBbuf.sec + 1) - 1;
  /* by ` */
  if (sctr < 0 || sctr > maxSector)
    return ERROR;
  sector = sctr;
  ptr = Malloc(DPBbuf.byte);
  edit((int)ptr, DPBbuf.byte, 0, funcSect);
  free(ptr);
  return 0;
}

static int funcSect(int keyNo)
{
  switch (keyNo)
    {
    case FUNC_PRE:
      B_LOCATE(33, 3);
      B_PRINT("\33[36m[[[ \33[35m@ \33[36m]]]");
      B_LOCATE(30, 5);
      B_PRINT("\33[31mhCu      ZN^[ mD\33[33m");
      B_LOCATE(42, 5);
      B_COLOR(7);
      B_PUTC(CurDrive + ('A'-1));
      B_PUTC(':');
      FNCKEYST(1, MesFKeyDriveC);
      FNCKEYST(2, MesFKeyReadC);
      FNCKEYST(3, MesFKeyWriteC);
      FNCKEYST(9, MesFKeyNxtSctrC);
      FNCKEYST(10, MesFKeyLstSctrC);
      FNCKEYST(12, MesFKeyLoadC);
      FNCKEYST(13, MesFKeySaveC);
      FNCKEYST(19, MesFKeyHdSctrC);
      FNCKEYST(20, MesFKeySctrNoC);
      B_CUROFF();
      return dRead(ptr);
    case 1:
      if (checkHenkouEdit(HenDRIVE))
	return FUNC_NORMAL;
      B_LOCATE(42, 29);
      B_PRINT(MesDriveNameQ);
      {
	int d = GetASC();
	keyNo = toupper(d) - ('A'-1);
      }
      B_LOCATE(0, 29);
      B_ERA_AL();
      B_CUROFF();
      if (keyNo < 1 || keyNo > 26)
	return FUNC_NORMAL;
      if (GETDPB(keyNo, &DPBbuf) < 0)
	return FUNC_NORMAL;
      DPRINT("max FAT %X\n", DPBbuf.maxfat);
      Is2Bytes = (DPBbuf.maxfat > 0xff8) ? ((DPBbuf.ide != 0xf7) ? 2 : 1) : 0;
      /* 94/9/14 */
      maxSector = DPBbuf.datasec + (DPBbuf.maxfat - 3) * (DPBbuf.sec + 1) - 1;
      /* by ` */
      CurDrive = keyNo;
      keyNo = 0;
      B_LOCATE(42, 5);
      B_COLOR(7);
      B_PUTC(CurDrive + ('A'-1));
      B_PUTC(':');
      B_CUROFF();
      break;
    case 2:
      if (checkHenkouEdit(HenREAD))
	return FUNC_NORMAL;
      keyNo = 0;
      break;
    case 3:
      B_LOCATE(22, 29);
      B_PRINT(MesWriteOKQ);
      keyNo = GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (keyNo == 0x16)
	if (!diskwrt(0, ptr, CurDrive, sector, 1))
	  henkouEdit = 0;
      return FUNC_NORMAL;
    case 9:
      keyNo = sector + 1;
      break;
    case 10:
      keyNo = sector - 1;
      break;
    case 12:
      funcLOAD();
      return FUNC_NORMAL;
    case 13:
      funcSAVE();
      return FUNC_NORMAL;
    case 19:
      keyNo = 0;
      break;
    case 20:
      B_LOCATE(36, 29);
      B_PRINT("\33[37mZN^[ m H $");
      keyNo = GetNum(16, 8, sector);
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (keyNo == ERROR)
	return FUNC_NORMAL;
      if (keyNo > maxSector)
	keyNo = maxSector;
      break;
    case 29:
      keyNo = sector + 1;
      if (keyNo > maxSector)
	return FUNC_ERROR;
      break;
    case 30:
      keyNo = sector - 1;
      if (keyNo < 0)
	return FUNC_ERROR;
      break;
    default:
      return FUNC_NORMAL;
    }
  if (keyNo < 0)
    keyNo = maxSector;
  if (keyNo > maxSector)
    keyNo = 0;
  if (checkHenkouEdit(HenSECTOR))
    return FUNC_ERROR;
  sector = keyNo;
  if (dRead(ptr))
    {
      Post();
      exit(0);
    }
  Dump(adrEdit, topEdit - offset);
  return FUNC_NORMAL;
}
